//---------------------------------------------------------------------------

#include <vcl.h>
#include <iterator>
#include "algostuff.hpp"

#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;

std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

int main()
{
  deque<int> coll1;
  vector<int> coll6(6);      //  6 
  vector<int> coll30(30);    //  30 

  INSERT_ELEMENTS(coll1,3,7);
  INSERT_ELEMENTS(coll1,2,6);
  INSERT_ELEMENTS(coll1,1,5);
  PRINT_ELEMENTS(coll1," :\n");

  //    coll1  coll6
  vector<int>::iterator pos6;
  pos6 = partial_sort_copy (coll1.begin(), coll1.end(),
                            coll6.begin(), coll6.end());

  //    
  cout << ToRus("   :\n");
  copy (coll6.begin(), pos6,
        ostream_iterator<int>(cout," "));
  cout << endl;

  //    coll1  coll30
  vector<int>::iterator pos30;
  pos30 = partial_sort_copy (coll1.begin(), coll1.end(),
                             coll30.begin(), coll30.end(),
                             greater<int>());

  //    
  cout << ToRus("    :\n");
  copy (coll30.begin(), pos30,
        ostream_iterator<int>(cout," "));
  cout << endl;


  getch();
  return 0;
}

//---------------------------------------------------------------------------